<!DOCTYPE HTML>
<!-- NewPage -->
<html lang="en">
<head>
<!-- Generated by javadoc (11.0.8) on Wed Aug 12 16:32:57 CEST 2020 -->
<title>QuerySpec</title>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8">
<meta name="dc.created" content="2020-08-12">
<link rel="stylesheet" type="text/css" href="../../../../stylesheet.css" title="Style">
<link rel="stylesheet" type="text/css" href="../../../../jquery/jquery-ui.css" title="Style">
<script type="text/javascript" src="../../../../script.js"></script>
<script type="text/javascript" src="../../../../jquery/jszip/dist/jszip.min.js"></script>
<script type="text/javascript" src="../../../../jquery/jszip-utils/dist/jszip-utils.min.js"></script>
<!--[if IE]>
<script type="text/javascript" src="../../../../jquery/jszip-utils/dist/jszip-utils-ie.min.js"></script>
<![endif]-->
<script type="text/javascript" src="../../../../jquery/jquery-3.3.1.js"></script>
<script type="text/javascript" src="../../../../jquery/jquery-migrate-3.0.1.js"></script>
<script type="text/javascript" src="../../../../jquery/jquery-ui.js"></script>
</head>
<body>
<script type="text/javascript"><!--
    try {
        if (location.href.indexOf('is-external=true') == -1) {
            parent.document.title="QuerySpec";
        }
    }
    catch(err) {
    }
//-->
var data = {"i0":10,"i1":10,"i2":10,"i3":10,"i4":10,"i5":10,"i6":10,"i7":10,"i8":10,"i9":10,"i10":10,"i11":10,"i12":10,"i13":10,"i14":10,"i15":10,"i16":10,"i17":10,"i18":10,"i19":10};
var tabs = {65535:["t0","All Methods"],2:["t2","Instance Methods"],8:["t4","Concrete Methods"]};
var altColor = "altColor";
var rowColor = "rowColor";
var tableTab = "tableTab";
var activeTableTab = "activeTableTab";
var pathtoroot = "../../../../";
var useModuleDirectories = true;
loadScripts(document, 'script');</script>
<noscript>
<div>JavaScript is disabled on your browser.</div>
</noscript>
<header role="banner">
<nav role="navigation">
<div class="fixedNav">
<!-- ========= START OF TOP NAVBAR ======= -->
<div class="topNav"><a id="navbar.top">
<!--   -->
</a>
<div class="skipNav"><a href="#skip.navbar.top" title="Skip navigation links">Skip navigation links</a></div>
<a id="navbar.top.firstrow">
<!--   -->
</a>
<ul class="navList" title="Navigation">
<li><a href="../../../../index.html">Overview</a></li>
<li><a href="package-summary.html">Package</a></li>
<li class="navBarCell1Rev">Class</li>
<li><a href="class-use/QuerySpec.html">Use</a></li>
<li><a href="package-tree.html">Tree</a></li>
<li><a href="../../../../deprecated-list.html">Deprecated</a></li>
<li><a href="../../../../index-files/index-1.html">Index</a></li>
<li><a href="../../../../help-doc.html">Help</a></li>
</ul>
</div>
<div class="subNav">
<ul class="navList" id="allclasses_navbar_top">
<li><a href="../../../../allclasses.html">All&nbsp;Classes</a></li>
</ul>
<ul class="navListSearch">
<li><label for="search">SEARCH:</label>
<input type="text" id="search" value="search" disabled="disabled">
<input type="reset" id="reset" value="reset" disabled="disabled">
</li>
</ul>
<div>
<script type="text/javascript"><!--
  allClassesLink = document.getElementById("allclasses_navbar_top");
  if(window==top) {
    allClassesLink.style.display = "block";
  }
  else {
    allClassesLink.style.display = "none";
  }
  //-->
</script>
<noscript>
<div>JavaScript is disabled on your browser.</div>
</noscript>
</div>
<div>
<ul class="subNavList">
<li>Summary:&nbsp;</li>
<li>Nested&nbsp;|&nbsp;</li>
<li>Field&nbsp;|&nbsp;</li>
<li><a href="#constructor.summary">Constr</a>&nbsp;|&nbsp;</li>
<li><a href="#method.summary">Method</a></li>
</ul>
<ul class="subNavList">
<li>Detail:&nbsp;</li>
<li>Field&nbsp;|&nbsp;</li>
<li><a href="#constructor.detail">Constr</a>&nbsp;|&nbsp;</li>
<li><a href="#method.detail">Method</a></li>
</ul>
</div>
<a id="skip.navbar.top">
<!--   -->
</a></div>
<!-- ========= END OF TOP NAVBAR ========= -->
</div>
<div class="navPadding">&nbsp;</div>
<script type="text/javascript"><!--
$('.navPadding').css('padding-top', $('.fixedNav').css("height"));
//-->
</script>
</nav>
</header>
<!-- ======== START OF CLASS DATA ======== -->
<main role="main">
<div class="header">
<div class="subTitle"><span class="packageLabelInType">Package</span>&nbsp;<a href="package-summary.html">nl.naturalis.nba.api</a></div>
<h2 title="Class QuerySpec" class="title">Class QuerySpec</h2>
</div>
<div class="contentContainer">
<ul class="inheritance">
<li><a href="https://docs.oracle.com/en/java/javase/11/docs/api/java.base/java/lang/Object.html?is-external=true" title="class or interface in java.lang" class="externalLink">java.lang.Object</a></li>
<li>
<ul class="inheritance">
<li>nl.naturalis.nba.api.QuerySpec</li>
</ul>
</li>
</ul>
<div class="description">
<ul class="blockList">
<li class="blockList">
<dl>
<dt>Direct Known Subclasses:</dt>
<dd><code><a href="GroupByScientificNameQuerySpec.html" title="class in nl.naturalis.nba.api">GroupByScientificNameQuerySpec</a></code>, <code><a href="NameResolutionQuerySpec.html" title="class in nl.naturalis.nba.api">NameResolutionQuerySpec</a></code></dd>
</dl>
<hr>
<pre>public class <span class="typeNameLabel">QuerySpec</span>
extends <a href="https://docs.oracle.com/en/java/javase/11/docs/api/java.base/java/lang/Object.html?is-external=true" title="class or interface in java.lang" class="externalLink">Object</a></pre>
<div class="block"><p>
 A <code>QuerySpec</code> object enables you to specify a query for the NBA. It
 contains the following properties, each covering a different aspect of the
 query:
 <ul>
 <li><i>conditions</i>: The search criteria a.k.a. query conditions. Only
 documents that satisfy all search criteria or at least one (depending on the
 <i>logicalOperator</i>) are returned.</li>
 <li><i>logicalOperator</i>: (AND/OR) Specifies whether a document must
 satisfy all search criteria or just one in order to be returned.
 <li><i>constantScore</i>: If true, no relevance scores will be calculated for
 the returned documents. By default Elasticsearch not only determines whether
 a document matches your search criteria, but also <i>how well</i> it matches
 them, expressed as a so-called relevance score. If you are not interested in
 relevance scores, set <i>constantScore</i> to <code>true</code>, as there is some
 performance overhead associated with calculating relevance scores.
 <li><i>fields</i>: The fields to be returned. <a href="model/Specimen.html" title="class in nl.naturalis.nba.api.model"><code>Specimen</code></a>, <a href="model/Taxon.html" title="class in nl.naturalis.nba.api.model"><code>Taxon</code></a>
 and <a href="model/MultiMediaObject.html" title="class in nl.naturalis.nba.api.model"><code>MultiMediaObject</code></a> documents are large documents containing lots of
 fields. If you are only interested in a few fields, use the <code>fields</code>
 property to specify them.</li>
 <li><i>size</i>: The number of documents to return. This is similar to the
 LIMIT parameter in SQL queries.</li>
 <li><i>from</i>: The offset in the result set from which to return the
 documents.
 <li><i>sortFields</i>: Specifies the field(s) on which to sort the documents.
 </ul>
 </p>
 <h3>Providing query specifications through the REST API</h3>
 <p>
 Whenever a method in the formal API takes a <code>QuerySpec</code> object, the
 REST API lets you access that method using either a GET or a POST request.
 </p>
 <p>
 <b>Encoding a <code>QuerySpec</code> in a GET request</b>
 </p>
 <p>
 With GET requests you have two options the encode the <code>QuerySpec</code>
 object in the URL. One option is to provide a query parameter named
 "_querySpec" whose value is the JSON-encoded <code>QuerySpec</code> object (i.e.
 the <code>QuerySpec</code> object serialized to JSON). For example:
 </p>

 <pre>
 https://api.biodiversitydata.nl/v2/specimen/query?_querySpec=%7B%22conditions%22%3A%5B%7B%22field%22%3A%22sourceSystem.code%22%2C%22operator%22%3A%22EQUALS%22%2C%22value%22%3A%22BRAHMS%22%7D%5D%2C%22from%22%3A0%2C%22size%22%3A0%7D
 </pre>
 <p>
 Since these URLs are hard to read and construct for humans, you can also
 encode the query specification as follows:
 </p>
 <p>
 <ol>
 <li>Every query parameter that does not start with an underscore is turned
 into a <a href="QueryCondition.html" title="class in nl.naturalis.nba.api"><code>query condition</code></a>. For example:

 <pre>
 https://api.biodiversitydata.nl/v2/specimen/query?sourceSystem.code=CRS&recordBasis=FossileSpecimen
 </pre>

 <li>The <code>_fields</code> parameter can be used to set the fields you want
 returned in the response. You can specify multiple fields by separating them
 with a comma. See <a href="#setFields(java.util.List)"><code>setFields</code></a>.
 <li>The <code>_from</code> parameter can be used to specify an result set offset.
 See <a href="#setFrom(java.lang.Integer)"><code>setFrom</code></a>.
 <li>The <code>_size</code> parameter can be used to specify the maximum number of
 documents to return. See <a href="#setSize(java.lang.Integer)"><code>setSize</code></a>.
 <li>The <code>_sortFields</code> parameter can be used to specify the fields on
 which to sort. You can specify multiple fields as well as sort directions by
 using commas to separate the fields and colons the separate field from sort
 direction. See <a href="#setSortFields(java.util.List)"><code>setSortFields</code></a>. For example:

 <pre>
 https://api.biodiversitydata.nl/v2/specimen/query?sourceSystem.code=CRS&_sortFields=recordBasis:ASC,unitID:DESC
 </pre>

 <li>The <code>_logicalOperator</code> parameter can be used to specify the logical
 operator joining the query conditions (either AND or OR). See
 <a href="#setLogicalOperator(nl.naturalis.nba.api.LogicalOperator)"><code>setLogicalOperator</code></a>.
 <li>The <code>_ignoreCase</code> parameter can be used to issue a case-insensitive
 search.
 </ol>
 </p>
 <p>
 You cannot mix the two encoding options. You must <b>either</b> provide a
 <code>_querySpec</code> query parameter <b>or</b> use the combination of
 parameters listed above. Complex queries with operators other than
 <a href="ComparisonOperator.html#EQUALS"><code>ComparisonOperator.EQUALS</code></a> or with nested query conditions are not
 possible with the second option.
 </p>
 <p>
 <b>Encoding a <code>QuerySpec</code> in a POST request</b>
 </p>
 <p>
 When using a POST requests you again have two options to encode the
 <code>QuerySpec</code> object;
 <ol>
 <li>Set the Content-Type header of the request to
 application/x-www-form-urlencoded (or leave it empty) and provide a
 "_querySpec" form parameter in the request body whose value is the
 JSON-encoded <code>QuerySpec</code> object.
 <li>Set the Content-Type header of the request to application/json and set
 the request body to the JSON represention of the <code>QuerySpec</code> object
 (<i>without</i> using the <code>_querySpec</code> form parameter). In other words,
 the request body consists of nothing but the JSON representing the
 <code>QuerySpec</code> object.
 </ol>
 </p>
 <h3>Non-scoring queries</h3>
 <p>
 You can turn a <code>QuerySpec</code> into a so-called non-scoring query by
 setting the <a href="#setConstantScore(boolean)"><code>constantScore</code></a> property to
 <code>true</code>. This will disable the calculation of relevance scores for
 documents returned from the query, which usually improves performance. Note
 that score calculation can also be disabled for individual
 <a href="QueryCondition.html" title="class in nl.naturalis.nba.api"><code>query conditions</code></a> within the <code>QuerySpec</code>. In that
 case those particular conditions do not contribute to the over-all score of
 the document while the other conditions still do. Disabling score calculation
 at the <code>QuerySpec</code>-level is more rigorous than disabling score
 calculation at the <code>QueryCondition</code>-level. Even if you disable scoring
 for each and every individual query condition within the <code>QuerySpec</code>,
 the final score may still end up being something else than 1. This is because
 Elasticsearch can and will also calculate a score from the boolean expression
 that results from combining all conditions using <a href="LogicalOperator.html#AND"><code>AND</code></a> or <a href="LogicalOperator.html#OR"><code>OR</code></a>. If you disable score calculation at
 the <code>QuerySpec</code>-level you are guaranteed that no score whatsoever will
 be calculated.
 </p>
 <h3>Example</h3>
 <p>
 Here is an example of building a query specification.
 </p>
 <p>
 <b>First, by way of reference, the SQL equivalent:</b>
 </p>
 <p>

 <pre>
 SELECT *
   FROM Specimen
  WHERE (gatheringEvent.gatheringPersons.fullName LIKE '%burg%' AND unitID = 'ZMA.MAM.100')
     OR UPPER(phaseOrStage) = 'EGG'
  ORDER BY unitID DESC
  LIMIT 100, 50
 </pre>
 </p>
 <p>
 <b>Next, using a <code>QuerySpec</code> object:</b>
 </p>
 <p>

 <pre>
 Condition condition1 = new Condition("gatheringEvent.gatheringPersons.fullName", CONTAINS,
     "burg");
 condition1.and("unitID", "=", "ZMA.MAM.100");
 Condition condition2 = new Condition("phaseOrStage", EQUALS_IC, "EGG");
 QuerySpec query = new QuerySpec();
 query.addCondition(condition1);
 query.addCondition(condition2);
 query.setLogicalOperator(OR);
 query.sortBy("unitID", false);
 query.setFrom(100);
 query.setSize(50);
 </pre>
 </p>
 <p>
 <b>Finally, the JSON representation of the <code>QuerySpec</code> (needed for the
 REST API):</b>
 </p>

 <pre>
 {
    "conditions" : [ {
        "field" : "gatheringEvent.gatheringPersons.fullName",
        "operator" : "CONTAINS",
        "value" : "burg",
        "and" : [ {
            "field" : "unitID",
            "operator" : "EQUALS",
            "value" : "ZMA.MAM.100"
        } ]
        }, {
        "field" : "phaseOrStage",
        "operator" : "EQUALS_IC",
        "value" : "EGG"
        } ],
    "logicalOperator" : "OR",
    "sortFields" : [ {
        "path" : "unitID",
        "ascending" : false
    } ],
    "from" : 100,
    "size" : 50
 }
 </pre></div>
<dl>
<dt><span class="simpleTagLabel">Author:</span></dt>
<dd>Ayco Holleman</dd>
</dl>
</li>
</ul>
</div>
<div class="summary">
<ul class="blockList">
<li class="blockList">
<!-- ======== CONSTRUCTOR SUMMARY ======== -->
<section role="region">
<ul class="blockList">
<li class="blockList"><a id="constructor.summary">
<!--   -->
</a>
<h3>Constructor Summary</h3>
<table class="memberSummary">
<caption><span>Constructors</span><span class="tabEnd">&nbsp;</span></caption>
<tr>
<th class="colFirst" scope="col">Constructor</th>
<th class="colLast" scope="col">Description</th>
</tr>
<tr class="altColor">
<th class="colConstructorName" scope="row"><code><span class="memberNameLink"><a href="#%3Cinit%3E()">QuerySpec</a></span>()</code></th>
<td class="colLast">&nbsp;</td>
</tr>
<tr class="rowColor">
<th class="colConstructorName" scope="row"><code><span class="memberNameLink"><a href="#%3Cinit%3E(nl.naturalis.nba.api.QuerySpec)">QuerySpec</a></span>&#8203;(<a href="QuerySpec.html" title="class in nl.naturalis.nba.api">QuerySpec</a>&nbsp;other)</code></th>
<td class="colLast">
<div class="block">Copy constructor</div>
</td>
</tr>
</table>
</li>
</ul>
</section>
<!-- ========== METHOD SUMMARY =========== -->
<section role="region">
<ul class="blockList">
<li class="blockList"><a id="method.summary">
<!--   -->
</a>
<h3>Method Summary</h3>
<table class="memberSummary">
<caption><span id="t0" class="activeTableTab"><span>All Methods</span><span class="tabEnd">&nbsp;</span></span><span id="t2" class="tableTab"><span><a href="javascript:show(2);">Instance Methods</a></span><span class="tabEnd">&nbsp;</span></span><span id="t4" class="tableTab"><span><a href="javascript:show(8);">Concrete Methods</a></span><span class="tabEnd">&nbsp;</span></span></caption>
<tr>
<th class="colFirst" scope="col">Modifier and Type</th>
<th class="colSecond" scope="col">Method</th>
<th class="colLast" scope="col">Description</th>
</tr>
<tr id="i0" class="altColor">
<td class="colFirst"><code>void</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#addCondition(nl.naturalis.nba.api.QueryCondition)">addCondition</a></span>&#8203;(<a href="QueryCondition.html" title="class in nl.naturalis.nba.api">QueryCondition</a>&nbsp;condition)</code></th>
<td class="colLast">
<div class="block">Adds the specified query condition to this <code>QuerySpec</code> instance.</div>
</td>
</tr>
<tr id="i1" class="rowColor">
<td class="colFirst"><code>void</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#addFields(java.lang.String...)">addFields</a></span>&#8203;(<a href="https://docs.oracle.com/en/java/javase/11/docs/api/java.base/java/lang/String.html?is-external=true" title="class or interface in java.lang" class="externalLink">String</a>...&nbsp;fields)</code></th>
<td class="colLast">
<div class="block">Specifies one or more fields to be returned in the query response.</div>
</td>
</tr>
<tr id="i2" class="altColor">
<td class="colFirst"><code>boolean</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#equals(java.lang.Object)">equals</a></span>&#8203;(<a href="https://docs.oracle.com/en/java/javase/11/docs/api/java.base/java/lang/Object.html?is-external=true" title="class or interface in java.lang" class="externalLink">Object</a>&nbsp;obj)</code></th>
<td class="colLast">&nbsp;</td>
</tr>
<tr id="i3" class="rowColor">
<td class="colFirst"><code><a href="https://docs.oracle.com/en/java/javase/11/docs/api/java.base/java/util/List.html?is-external=true" title="class or interface in java.util" class="externalLink">List</a>&lt;<a href="QueryCondition.html" title="class in nl.naturalis.nba.api">QueryCondition</a>&gt;</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#getConditions()">getConditions</a></span>()</code></th>
<td class="colLast">
<div class="block">Returns the conditions a&#46;k&#46;a&#46; criteria that the documents must
 satify.</div>
</td>
</tr>
<tr id="i4" class="altColor">
<td class="colFirst"><code><a href="https://docs.oracle.com/en/java/javase/11/docs/api/java.base/java/util/List.html?is-external=true" title="class or interface in java.util" class="externalLink">List</a>&lt;<a href="Path.html" title="class in nl.naturalis.nba.api">Path</a>&gt;</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#getFields()">getFields</a></span>()</code></th>
<td class="colLast">
<div class="block">Returns the fields to return in the query response.</div>
</td>
</tr>
<tr id="i5" class="rowColor">
<td class="colFirst"><code><a href="https://docs.oracle.com/en/java/javase/11/docs/api/java.base/java/lang/Integer.html?is-external=true" title="class or interface in java.lang" class="externalLink">Integer</a></code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#getFrom()">getFrom</a></span>()</code></th>
<td class="colLast">
<div class="block">Returns the offset in the total result set of documents satisfying the
 conditions of this <code>QuerySpec</code>.</div>
</td>
</tr>
<tr id="i6" class="altColor">
<td class="colFirst"><code><a href="LogicalOperator.html" title="enum in nl.naturalis.nba.api">LogicalOperator</a></code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#getLogicalOperator()">getLogicalOperator</a></span>()</code></th>
<td class="colLast">
<div class="block">Returns the logical operator (<a href="LogicalOperator.html#AND"><code>AND</code></a> or
 <a href="LogicalOperator.html#AND"><code>OR</code></a>) with which to join the
 <a href="#getConditions()"><code>query conditions</code></a>.</div>
</td>
</tr>
<tr id="i7" class="rowColor">
<td class="colFirst"><code><a href="https://docs.oracle.com/en/java/javase/11/docs/api/java.base/java/lang/Integer.html?is-external=true" title="class or interface in java.lang" class="externalLink">Integer</a></code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#getSize()">getSize</a></span>()</code></th>
<td class="colLast">
<div class="block">Returns the number of documents to return.</div>
</td>
</tr>
<tr id="i8" class="altColor">
<td class="colFirst"><code><a href="https://docs.oracle.com/en/java/javase/11/docs/api/java.base/java/util/List.html?is-external=true" title="class or interface in java.util" class="externalLink">List</a>&lt;<a href="SortField.html" title="class in nl.naturalis.nba.api">SortField</a>&gt;</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#getSortFields()">getSortFields</a></span>()</code></th>
<td class="colLast">
<div class="block">Returns the fields on which to sort the documents in the result set.</div>
</td>
</tr>
<tr id="i9" class="rowColor">
<td class="colFirst"><code>int</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#hashCode()">hashCode</a></span>()</code></th>
<td class="colLast">&nbsp;</td>
</tr>
<tr id="i10" class="altColor">
<td class="colFirst"><code>boolean</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#isConstantScore()">isConstantScore</a></span>()</code></th>
<td class="colLast">
<div class="block">Whether or not this is a non-scoring query.</div>
</td>
</tr>
<tr id="i11" class="rowColor">
<td class="colFirst"><code>void</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#setConditions(java.util.List)">setConditions</a></span>&#8203;(<a href="https://docs.oracle.com/en/java/javase/11/docs/api/java.base/java/util/List.html?is-external=true" title="class or interface in java.util" class="externalLink">List</a>&lt;<a href="QueryCondition.html" title="class in nl.naturalis.nba.api">QueryCondition</a>&gt;&nbsp;conditions)</code></th>
<td class="colLast">
<div class="block">Sets the conditions a&#46;k&#46;a&#46; criteria that the documents must
 satify.</div>
</td>
</tr>
<tr id="i12" class="altColor">
<td class="colFirst"><code>void</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#setConstantScore(boolean)">setConstantScore</a></span>&#8203;(boolean&nbsp;constantScore)</code></th>
<td class="colLast">
<div class="block">Make this a non-scoring query.</div>
</td>
</tr>
<tr id="i13" class="rowColor">
<td class="colFirst"><code>void</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#setFields(java.util.List)">setFields</a></span>&#8203;(<a href="https://docs.oracle.com/en/java/javase/11/docs/api/java.base/java/util/List.html?is-external=true" title="class or interface in java.util" class="externalLink">List</a>&lt;<a href="Path.html" title="class in nl.naturalis.nba.api">Path</a>&gt;&nbsp;fields)</code></th>
<td class="colLast">
<div class="block">Sets the fields to return in the query response.</div>
</td>
</tr>
<tr id="i14" class="altColor">
<td class="colFirst"><code>void</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#setFrom(java.lang.Integer)">setFrom</a></span>&#8203;(<a href="https://docs.oracle.com/en/java/javase/11/docs/api/java.base/java/lang/Integer.html?is-external=true" title="class or interface in java.lang" class="externalLink">Integer</a>&nbsp;from)</code></th>
<td class="colLast">
<div class="block">Sets the offset in the total result set of documents satisfying the
 conditions of this <code>QuerySpec</code>.</div>
</td>
</tr>
<tr id="i15" class="rowColor">
<td class="colFirst"><code>void</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#setLogicalOperator(nl.naturalis.nba.api.LogicalOperator)">setLogicalOperator</a></span>&#8203;(<a href="LogicalOperator.html" title="enum in nl.naturalis.nba.api">LogicalOperator</a>&nbsp;operator)</code></th>
<td class="colLast">
<div class="block">Sets the logical operator (<a href="LogicalOperator.html#AND"><code>AND</code></a> or
 <a href="LogicalOperator.html#AND"><code>OR</code></a>) with which to join the
 <a href="#getConditions()"><code>query conditions</code></a>.</div>
</td>
</tr>
<tr id="i16" class="altColor">
<td class="colFirst"><code>void</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#setSize(java.lang.Integer)">setSize</a></span>&#8203;(<a href="https://docs.oracle.com/en/java/javase/11/docs/api/java.base/java/lang/Integer.html?is-external=true" title="class or interface in java.lang" class="externalLink">Integer</a>&nbsp;size)</code></th>
<td class="colLast">
<div class="block">Sets the number of documents to return.</div>
</td>
</tr>
<tr id="i17" class="rowColor">
<td class="colFirst"><code>void</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#setSortFields(java.util.List)">setSortFields</a></span>&#8203;(<a href="https://docs.oracle.com/en/java/javase/11/docs/api/java.base/java/util/List.html?is-external=true" title="class or interface in java.util" class="externalLink">List</a>&lt;<a href="SortField.html" title="class in nl.naturalis.nba.api">SortField</a>&gt;&nbsp;sortFields)</code></th>
<td class="colLast">
<div class="block">Sets the fields on which to sort the documents in the result set.</div>
</td>
</tr>
<tr id="i18" class="altColor">
<td class="colFirst"><code>void</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#sortBy(java.lang.String)">sortBy</a></span>&#8203;(<a href="https://docs.oracle.com/en/java/javase/11/docs/api/java.base/java/lang/String.html?is-external=true" title="class or interface in java.lang" class="externalLink">String</a>&nbsp;field)</code></th>
<td class="colLast">
<div class="block">Causes the documents in the result set to be sorted in ascending order of the
 specified field.</div>
</td>
</tr>
<tr id="i19" class="rowColor">
<td class="colFirst"><code>void</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#sortBy(java.lang.String,nl.naturalis.nba.api.SortOrder)">sortBy</a></span>&#8203;(<a href="https://docs.oracle.com/en/java/javase/11/docs/api/java.base/java/lang/String.html?is-external=true" title="class or interface in java.lang" class="externalLink">String</a>&nbsp;field,
      <a href="SortOrder.html" title="enum in nl.naturalis.nba.api">SortOrder</a>&nbsp;sortOrder)</code></th>
<td class="colLast">
<div class="block">Causes the documents in the result set to be sorted on the specified field
 with the sort order determined by the <code>ascending</code> argument.</div>
</td>
</tr>
</table>
<ul class="blockList">
<li class="blockList"><a id="methods.inherited.from.class.java.lang.Object">
<!--   -->
</a>
<h3>Methods inherited from class&nbsp;java.lang.<a href="https://docs.oracle.com/en/java/javase/11/docs/api/java.base/java/lang/Object.html?is-external=true" title="class or interface in java.lang" class="externalLink">Object</a></h3>
<code><a href="https://docs.oracle.com/en/java/javase/11/docs/api/java.base/java/lang/Object.html?is-external=true#getClass()" title="class or interface in java.lang" class="externalLink">getClass</a>, <a href="https://docs.oracle.com/en/java/javase/11/docs/api/java.base/java/lang/Object.html?is-external=true#notify()" title="class or interface in java.lang" class="externalLink">notify</a>, <a href="https://docs.oracle.com/en/java/javase/11/docs/api/java.base/java/lang/Object.html?is-external=true#notifyAll()" title="class or interface in java.lang" class="externalLink">notifyAll</a>, <a href="https://docs.oracle.com/en/java/javase/11/docs/api/java.base/java/lang/Object.html?is-external=true#toString()" title="class or interface in java.lang" class="externalLink">toString</a>, <a href="https://docs.oracle.com/en/java/javase/11/docs/api/java.base/java/lang/Object.html?is-external=true#wait()" title="class or interface in java.lang" class="externalLink">wait</a>, <a href="https://docs.oracle.com/en/java/javase/11/docs/api/java.base/java/lang/Object.html?is-external=true#wait(long)" title="class or interface in java.lang" class="externalLink">wait</a>, <a href="https://docs.oracle.com/en/java/javase/11/docs/api/java.base/java/lang/Object.html?is-external=true#wait(long,int)" title="class or interface in java.lang" class="externalLink">wait</a></code></li>
</ul>
</li>
</ul>
</section>
</li>
</ul>
</div>
<div class="details">
<ul class="blockList">
<li class="blockList">
<!-- ========= CONSTRUCTOR DETAIL ======== -->
<section role="region">
<ul class="blockList">
<li class="blockList"><a id="constructor.detail">
<!--   -->
</a>
<h3>Constructor Detail</h3>
<a id="&lt;init&gt;()">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>QuerySpec</h4>
<pre>public&nbsp;QuerySpec()</pre>
</li>
</ul>
<a id="&lt;init&gt;(nl.naturalis.nba.api.QuerySpec)">
<!--   -->
</a>
<ul class="blockListLast">
<li class="blockList">
<h4>QuerySpec</h4>
<pre>public&nbsp;QuerySpec&#8203;(<a href="QuerySpec.html" title="class in nl.naturalis.nba.api">QuerySpec</a>&nbsp;other)</pre>
<div class="block">Copy constructor</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>other</code> - </dd>
</dl>
</li>
</ul>
</li>
</ul>
</section>
<!-- ============ METHOD DETAIL ========== -->
<section role="region">
<ul class="blockList">
<li class="blockList"><a id="method.detail">
<!--   -->
</a>
<h3>Method Detail</h3>
<a id="isConstantScore()">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>isConstantScore</h4>
<pre class="methodSignature">public&nbsp;boolean&nbsp;isConstantScore()</pre>
<div class="block">Whether or not this is a non-scoring query.</div>
<dl>
<dt><span class="returnLabel">Returns:</span></dt>
</dl>
</li>
</ul>
<a id="setConstantScore(boolean)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>setConstantScore</h4>
<pre class="methodSignature">public&nbsp;void&nbsp;setConstantScore&#8203;(boolean&nbsp;constantScore)</pre>
<div class="block">Make this a non-scoring query.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>constantScore</code> - </dd>
</dl>
</li>
</ul>
<a id="addFields(java.lang.String...)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>addFields</h4>
<pre class="methodSignature">public&nbsp;void&nbsp;addFields&#8203;(<a href="https://docs.oracle.com/en/java/javase/11/docs/api/java.base/java/lang/String.html?is-external=true" title="class or interface in java.lang" class="externalLink">String</a>...&nbsp;fields)</pre>
<div class="block">Specifies one or more fields to be returned in the query response. Akin to an
 SQL SELECT clause. The field must belong to the document type being queried.
 See <a href="#getFields()"><code>getFields</code></a>.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>fields</code> - </dd>
</dl>
</li>
</ul>
<a id="addCondition(nl.naturalis.nba.api.QueryCondition)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>addCondition</h4>
<pre class="methodSignature">public&nbsp;void&nbsp;addCondition&#8203;(<a href="QueryCondition.html" title="class in nl.naturalis.nba.api">QueryCondition</a>&nbsp;condition)</pre>
<div class="block">Adds the specified query condition to this <code>QuerySpec</code> instance.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>condition</code> - </dd>
</dl>
</li>
</ul>
<a id="sortBy(java.lang.String)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>sortBy</h4>
<pre class="methodSignature">public&nbsp;void&nbsp;sortBy&#8203;(<a href="https://docs.oracle.com/en/java/javase/11/docs/api/java.base/java/lang/String.html?is-external=true" title="class or interface in java.lang" class="externalLink">String</a>&nbsp;field)</pre>
<div class="block">Causes the documents in the result set to be sorted in ascending order of the
 specified field.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>field</code> - </dd>
</dl>
</li>
</ul>
<a id="sortBy(java.lang.String,nl.naturalis.nba.api.SortOrder)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>sortBy</h4>
<pre class="methodSignature">public&nbsp;void&nbsp;sortBy&#8203;(<a href="https://docs.oracle.com/en/java/javase/11/docs/api/java.base/java/lang/String.html?is-external=true" title="class or interface in java.lang" class="externalLink">String</a>&nbsp;field,
                   <a href="SortOrder.html" title="enum in nl.naturalis.nba.api">SortOrder</a>&nbsp;sortOrder)</pre>
<div class="block">Causes the documents in the result set to be sorted on the specified field
 with the sort order determined by the <code>ascending</code> argument.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>field</code> - </dd>
</dl>
</li>
</ul>
<a id="getFields()">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getFields</h4>
<pre class="methodSignature">public&nbsp;<a href="https://docs.oracle.com/en/java/javase/11/docs/api/java.base/java/util/List.html?is-external=true" title="class or interface in java.util" class="externalLink">List</a>&lt;<a href="Path.html" title="class in nl.naturalis.nba.api">Path</a>&gt;&nbsp;getFields()</pre>
<div class="block">Returns the fields to return in the query response. This is akin to a SQL
 SELECT clause. By default all fields will be selected.</div>
<dl>
<dt><span class="returnLabel">Returns:</span></dt>
</dl>
</li>
</ul>
<a id="setFields(java.util.List)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>setFields</h4>
<pre class="methodSignature">public&nbsp;void&nbsp;setFields&#8203;(<a href="https://docs.oracle.com/en/java/javase/11/docs/api/java.base/java/util/List.html?is-external=true" title="class or interface in java.util" class="externalLink">List</a>&lt;<a href="Path.html" title="class in nl.naturalis.nba.api">Path</a>&gt;&nbsp;fields)</pre>
<div class="block">Sets the fields to return in the query response. This is akin to a SQL SELECT
 clause. By default all fields will be selected. Be aware of the effect this
 method has when querying data model objects like <a href="model/Taxon.html" title="class in nl.naturalis.nba.api.model"><code>taxa</code></a> or
 <a href="model/Specimen.html" title="class in nl.naturalis.nba.api.model"><code>specimens</code></a> (e.g. with the <a href="INbaAccess.html#query(nl.naturalis.nba.api.QuerySpec)"><code>query</code></a> method): you <i>still</i> get back full-blown <code>Taxon</code> c.q.
 <code>Specimen</code> objects, only with all non-selected fields set to their
 default value (<code>null</code> for strings, dates and objects, zero for number
 fields and <code>false</code> for boolean fields). Thus, the value of a
 non-selected field has no relation to its actual value in the NBA data store.
 This is especially confusing if you also specified a <a href="QueryCondition.html" title="class in nl.naturalis.nba.api"><code>QueryCondition</code></a>
 for that field (e.g. you specified it to be <code>true</code> but in the query
 result it appears to be <code>false</code> - the default boolean value).
 Therefore: <i>do not read values of fields you did not select!</i></div>
</li>
</ul>
<a id="getLogicalOperator()">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getLogicalOperator</h4>
<pre class="methodSignature">public&nbsp;<a href="LogicalOperator.html" title="enum in nl.naturalis.nba.api">LogicalOperator</a>&nbsp;getLogicalOperator()</pre>
<div class="block">Returns the logical operator (<a href="LogicalOperator.html#AND"><code>AND</code></a> or
 <a href="LogicalOperator.html#AND"><code>OR</code></a>) with which to join the
 <a href="#getConditions()"><code>query conditions</code></a>. Defaults to <code>AND</code>. Note that
 any condition may itself contain a list of sibling conditions.</div>
<dl>
<dt><span class="returnLabel">Returns:</span></dt>
</dl>
</li>
</ul>
<a id="setLogicalOperator(nl.naturalis.nba.api.LogicalOperator)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>setLogicalOperator</h4>
<pre class="methodSignature">public&nbsp;void&nbsp;setLogicalOperator&#8203;(<a href="LogicalOperator.html" title="enum in nl.naturalis.nba.api">LogicalOperator</a>&nbsp;operator)</pre>
<div class="block">Sets the logical operator (<a href="LogicalOperator.html#AND"><code>AND</code></a> or
 <a href="LogicalOperator.html#AND"><code>OR</code></a>) with which to join the
 <a href="#getConditions()"><code>query conditions</code></a>. Defaults to <code>AND</code>. Note that
 any condition may itself contain a list of sibling conditions.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>operator</code> - </dd>
</dl>
</li>
</ul>
<a id="getConditions()">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getConditions</h4>
<pre class="methodSignature">public&nbsp;<a href="https://docs.oracle.com/en/java/javase/11/docs/api/java.base/java/util/List.html?is-external=true" title="class or interface in java.util" class="externalLink">List</a>&lt;<a href="QueryCondition.html" title="class in nl.naturalis.nba.api">QueryCondition</a>&gt;&nbsp;getConditions()</pre>
<div class="block">Returns the conditions a&#46;k&#46;a&#46; criteria that the documents must
 satify.</div>
<dl>
<dt><span class="returnLabel">Returns:</span></dt>
</dl>
</li>
</ul>
<a id="setConditions(java.util.List)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>setConditions</h4>
<pre class="methodSignature">public&nbsp;void&nbsp;setConditions&#8203;(<a href="https://docs.oracle.com/en/java/javase/11/docs/api/java.base/java/util/List.html?is-external=true" title="class or interface in java.util" class="externalLink">List</a>&lt;<a href="QueryCondition.html" title="class in nl.naturalis.nba.api">QueryCondition</a>&gt;&nbsp;conditions)</pre>
<div class="block">Sets the conditions a&#46;k&#46;a&#46; criteria that the documents must
 satify.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>conditions</code> - </dd>
</dl>
</li>
</ul>
<a id="getSortFields()">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getSortFields</h4>
<pre class="methodSignature">public&nbsp;<a href="https://docs.oracle.com/en/java/javase/11/docs/api/java.base/java/util/List.html?is-external=true" title="class or interface in java.util" class="externalLink">List</a>&lt;<a href="SortField.html" title="class in nl.naturalis.nba.api">SortField</a>&gt;&nbsp;getSortFields()</pre>
<div class="block">Returns the fields on which to sort the documents in the result set.</div>
<dl>
<dt><span class="returnLabel">Returns:</span></dt>
</dl>
</li>
</ul>
<a id="setSortFields(java.util.List)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>setSortFields</h4>
<pre class="methodSignature">public&nbsp;void&nbsp;setSortFields&#8203;(<a href="https://docs.oracle.com/en/java/javase/11/docs/api/java.base/java/util/List.html?is-external=true" title="class or interface in java.util" class="externalLink">List</a>&lt;<a href="SortField.html" title="class in nl.naturalis.nba.api">SortField</a>&gt;&nbsp;sortFields)</pre>
<div class="block">Sets the fields on which to sort the documents in the result set.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>sortFields</code> - </dd>
</dl>
</li>
</ul>
<a id="getFrom()">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getFrom</h4>
<pre class="methodSignature">public&nbsp;<a href="https://docs.oracle.com/en/java/javase/11/docs/api/java.base/java/lang/Integer.html?is-external=true" title="class or interface in java.lang" class="externalLink">Integer</a>&nbsp;getFrom()</pre>
<div class="block">Returns the offset in the total result set of documents satisfying the
 conditions of this <code>QuerySpec</code>. Defaults to 0 (zero).</div>
<dl>
<dt><span class="returnLabel">Returns:</span></dt>
</dl>
</li>
</ul>
<a id="setFrom(java.lang.Integer)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>setFrom</h4>
<pre class="methodSignature">public&nbsp;void&nbsp;setFrom&#8203;(<a href="https://docs.oracle.com/en/java/javase/11/docs/api/java.base/java/lang/Integer.html?is-external=true" title="class or interface in java.lang" class="externalLink">Integer</a>&nbsp;from)</pre>
<div class="block">Sets the offset in the total result set of documents satisfying the
 conditions of this <code>QuerySpec</code>.</div>
</li>
</ul>
<a id="getSize()">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getSize</h4>
<pre class="methodSignature">public&nbsp;<a href="https://docs.oracle.com/en/java/javase/11/docs/api/java.base/java/lang/Integer.html?is-external=true" title="class or interface in java.lang" class="externalLink">Integer</a>&nbsp;getSize()</pre>
<div class="block">Returns the number of documents to return. Defaults to 10.</div>
<dl>
<dt><span class="returnLabel">Returns:</span></dt>
</dl>
</li>
</ul>
<a id="setSize(java.lang.Integer)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>setSize</h4>
<pre class="methodSignature">public&nbsp;void&nbsp;setSize&#8203;(<a href="https://docs.oracle.com/en/java/javase/11/docs/api/java.base/java/lang/Integer.html?is-external=true" title="class or interface in java.lang" class="externalLink">Integer</a>&nbsp;size)</pre>
<div class="block">Sets the number of documents to return.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>size</code> - </dd>
</dl>
</li>
</ul>
<a id="equals(java.lang.Object)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>equals</h4>
<pre class="methodSignature">public&nbsp;boolean&nbsp;equals&#8203;(<a href="https://docs.oracle.com/en/java/javase/11/docs/api/java.base/java/lang/Object.html?is-external=true" title="class or interface in java.lang" class="externalLink">Object</a>&nbsp;obj)</pre>
<dl>
<dt><span class="overrideSpecifyLabel">Overrides:</span></dt>
<dd><code><a href="https://docs.oracle.com/en/java/javase/11/docs/api/java.base/java/lang/Object.html?is-external=true#equals(java.lang.Object)" title="class or interface in java.lang" class="externalLink">equals</a></code>&nbsp;in class&nbsp;<code><a href="https://docs.oracle.com/en/java/javase/11/docs/api/java.base/java/lang/Object.html?is-external=true" title="class or interface in java.lang" class="externalLink">Object</a></code></dd>
</dl>
</li>
</ul>
<a id="hashCode()">
<!--   -->
</a>
<ul class="blockListLast">
<li class="blockList">
<h4>hashCode</h4>
<pre class="methodSignature">public&nbsp;int&nbsp;hashCode()</pre>
<dl>
<dt><span class="overrideSpecifyLabel">Overrides:</span></dt>
<dd><code><a href="https://docs.oracle.com/en/java/javase/11/docs/api/java.base/java/lang/Object.html?is-external=true#hashCode()" title="class or interface in java.lang" class="externalLink">hashCode</a></code>&nbsp;in class&nbsp;<code><a href="https://docs.oracle.com/en/java/javase/11/docs/api/java.base/java/lang/Object.html?is-external=true" title="class or interface in java.lang" class="externalLink">Object</a></code></dd>
</dl>
</li>
</ul>
</li>
</ul>
</section>
</li>
</ul>
</div>
</div>
</main>
<!-- ========= END OF CLASS DATA ========= -->
<footer role="contentinfo">
<nav role="navigation">
<!-- ======= START OF BOTTOM NAVBAR ====== -->
<div class="bottomNav"><a id="navbar.bottom">
<!--   -->
</a>
<div class="skipNav"><a href="#skip.navbar.bottom" title="Skip navigation links">Skip navigation links</a></div>
<a id="navbar.bottom.firstrow">
<!--   -->
</a>
<ul class="navList" title="Navigation">
<li><a href="../../../../index.html">Overview</a></li>
<li><a href="package-summary.html">Package</a></li>
<li class="navBarCell1Rev">Class</li>
<li><a href="class-use/QuerySpec.html">Use</a></li>
<li><a href="package-tree.html">Tree</a></li>
<li><a href="../../../../deprecated-list.html">Deprecated</a></li>
<li><a href="../../../../index-files/index-1.html">Index</a></li>
<li><a href="../../../../help-doc.html">Help</a></li>
</ul>
</div>
<div class="subNav">
<ul class="navList" id="allclasses_navbar_bottom">
<li><a href="../../../../allclasses.html">All&nbsp;Classes</a></li>
</ul>
<div>
<script type="text/javascript"><!--
  allClassesLink = document.getElementById("allclasses_navbar_bottom");
  if(window==top) {
    allClassesLink.style.display = "block";
  }
  else {
    allClassesLink.style.display = "none";
  }
  //-->
</script>
<noscript>
<div>JavaScript is disabled on your browser.</div>
</noscript>
</div>
<div>
<ul class="subNavList">
<li>Summary:&nbsp;</li>
<li>Nested&nbsp;|&nbsp;</li>
<li>Field&nbsp;|&nbsp;</li>
<li><a href="#constructor.summary">Constr</a>&nbsp;|&nbsp;</li>
<li><a href="#method.summary">Method</a></li>
</ul>
<ul class="subNavList">
<li>Detail:&nbsp;</li>
<li>Field&nbsp;|&nbsp;</li>
<li><a href="#constructor.detail">Constr</a>&nbsp;|&nbsp;</li>
<li><a href="#method.detail">Method</a></li>
</ul>
</div>
<a id="skip.navbar.bottom">
<!--   -->
</a></div>
<!-- ======== END OF BOTTOM NAVBAR ======= -->
</nav>
</footer>
</body>
</html>
